/***************************************************************************
 *   Copyright (C) 2004 by Alessandro Bonometti                            *
 *   bauno@bauniga.baita                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "updopt.h"
#include <kiconloader.h>
#include <kpushbutton.h>
#include <qradiobutton.h>
#include <qspinbox.h>

UpdOpt::UpdOpt(int& h, QWidget* parent, const char* name, bool modal, WFlags fl)
	: UpdOptDlg(parent,name, modal,fl), headers(h)
{
	buttonOk->setIconSet(KGlobal::iconLoader()->loadIcon("button_ok", KIcon::Small, 0, false));
	buttonCancel->setIconSet(KGlobal::iconLoader()->loadIcon("button_cancel", KIcon::Small, 0, false));
	allBtn->setChecked(true);
}

UpdOpt::~UpdOpt()
{
}

/*$SPECIALIZATION$*/
void UpdOpt::reject()
{
	
	
	QDialog::reject();
}

void UpdOpt::accept()
{
	if (allBtn->isChecked())
		headers=0;
	else {
		headers=headersSpin->value();
	}
	QDialog::accept();
}



#include "updopt.moc"

